unit glavno;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, podpora, ComCtrls;

type
  Tpodlaga = class(TForm)
    dlgVhod: TOpenDialog;
    dlgIzhod: TSaveDialog;
    btVhod: TButton;
    btIzhod: TButton;
    btIzvedi: TButton;
    edVhod: TEdit;
    edIzhod: TEdit;
    lblStanje: TLabel;
    procedure btVhodClick(Sender: TObject);
    procedure btIzhodClick(Sender: TObject);
    procedure btIzvediClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    pravila: kElement;
    dat: text;
    k: integer;
  end;

var
  podlaga: Tpodlaga;

implementation

{$R *.DFM}

procedure Tpodlaga.FormCreate(Sender: TObject);
begin
  podlaga.scaleBy (120, pixelsPerInch);
  pravila:=nil;
end;

procedure Tpodlaga.btVhodClick(Sender: TObject);
  var
    zac: string;
    meja: integer;
    noviEl: kElement;
    novoVoz: kVozlisce;
begin
  if dlgVhod.execute then begin
    prazniSeznam (pravila);
    pravila:=nil;
    edVhod.text:=dlgVhod.fileName;
    assignFile (dat, edVhod.text);
    reset (dat);
    readln (dat, k);
    while not eOF (dat) do begin
      readln (dat, zac);
      meja:=pos (':', zac);
      narediEl (noviEl);
      narediVoz (novoVoz);
      novoVoz^.str:=copy (zac, 1, meja-2);
      noviEl^.kaj:=novoVoz;
      zac:=copy (zac, meja+2, length (zac)-meja-1);
      repeat
        meja:=pos (' ', zac);
        narediVoz (novoVoz);
        if meja<>0 then novoVoz^.str:=copy (zac, 1, meja-1) else
          if length (zac)=0 then novoVoz^.str:='@' else novoVoz^.str:=zac;
        dodajNiz (noviEl^.vKaj, novoVoz);
        zac:=copy (zac, meja+1, length (zac)-meja);
      until meja=0;
      dodajEl (pravila, noviEl);
    end;
    closeFile (dat);
  end;
end;

procedure Tpodlaga.btIzhodClick(Sender: TObject);
begin
  if dlgIzhod.execute then edIzhod.text:=dlgIzhod.fileName;
end;

procedure Tpodlaga.btIzvediClick(Sender: TObject);
  var
    vrsta: string;
    trenutniEl: kElement;
    resitve: kVozlisce;
    cas1, cas2: double;

  function prevedi (kaj, pot: kVozlisce; doZdaj: integer): kVozlisce;
    var
      trenutniEl: kElement;
      nasel, cikel: boolean;
      prevajano, prevedeno, delneRes, zac, zac1: kVozlisce;
  begin
    delneRes:=nil;
    prevajano:=kaj;
    repeat
      nasel:=false;
      cikel:=false;
      prevedeno:=nil;
      trenutniEl:=pravila;
      repeat
        if prevajano^.str=trenutniEl^.kaj^.str then begin
          zac:=pot;
          while (zac<>nil) and not cikel do begin
            if zac^.str=prevajano^.str then cikel:=true;
            zac:=zac^.nasNiz;
          end;
          if not cikel then begin
            narediVoz (zac);
            zac^.str:=prevajano^.str;
            dodajNiz (zac, pot);
            zac:=prevedi (trenutniEl^.vKaj, zac, doZdaj);
            dodajPrevod (prevedeno, zac);
            nasel:=true;
          end;
        end;
        trenutniEl:=trenutniEl^.naslednji;
      until (trenutniEl=nil) or cikel;
      if not nasel then begin
        narediVoz (prevedeno);
        prevedeno^.str:=prevajano^.str;
        if cikel then prevedeno^.str:=prevedeno^.str+' (cikel)';
        if prevajano^.str<>'@' then prevedeno^.d:=1;
      end else
        if prevedeno^.nasPrevod<>nil then begin
          zac:=prevedeno;
          while zac^.nasPrevod<>nil do begin
            if vsotaDNiz (zac^.nasPrevod)<vsotaDNiz (prevedeno) then begin
              zac1:=zac^.nasPrevod;
              zac^.nasPrevod:=zac1^.nasPrevod;
              zac1^.nasPrevod:=prevedeno;
              prevedeno:=zac1;
            end else zac:=zac^.nasPrevod;
          end;
        end;
      doZdaj:=doZdaj+prevedeno^.d;
      dodajNiz (delneRes, prevedeno);
      pot:=nil;
      prevajano:=prevajano^.nasNiz;
    until (prevajano=nil) or (doZdaj>=k);
    prevedi:=delneRes;
  end;

  procedure zapisi (kaj: kVozlisce; delniNiz: string; doZdaj: integer);
    var
      trenutnoVoz: kVozlisce;
      doZdaj1, meja: integer;
      delniNiz1, presl: string;
      nasel: boolean;
  begin
    trenutnoVoz:=kaj;
    repeat
      if length (delniNiz)>0 then
        delniNiz1:=delniNiz+' '+trenutnoVoz^.str
      else
        delniNiz1:=delniNiz+trenutnoVoz^.str;
      if trenutnoVoz^.str<>'@' then doZdaj1:=doZdaj+1 else doZdaj1:=doZdaj;
      nasel:=false;
      if doZdaj1<k then begin
        if trenutnoVoz^.nasNiz<>nil then begin
          zapisi (trenutnoVoz^.nasNiz, delniNiz1, doZdaj1);
          nasel:=true;
        end;
      end;
      if (doZdaj1=k) or ((doZdaj1<k) and (not nasel)) then begin
        meja:=pos ('@', delniNiz1);
        while (meja>0) and (delniNiz1<>'@') do begin
          if (meja=length (delniNiz1)) or (meja=1) then presl:='' else presl:=' ';
          delniNiz1:=copy (delniNiz1, 1, meja-2)+presl+copy (delniNiz1, meja+2, length (delniNiz1)-meja-1);
          meja:=pos ('@', delniNiz1);
        end;
        if pos (delniNiz1, vrsta)=0 then vrsta:=vrsta+delniNiz1+', ';
      end;
      trenutnoVoz:=trenutnoVoz^.nasPrevod;
    until trenutnoVoz=nil;
  end;

begin
  assignFile (dat, edIzhod.text);
  rewrite (dat);
  lblStanje.caption:='Postopek tece.';
  podlaga.repaint;
  trenutniEl:=pravila;
  cas1:=time;
  repeat
    if (trenutniEl^.naslednji=nil) or (trenutniEl^.kaj^.str<>trenutniEl^.naslednji^.kaj^.str) then begin
      vrsta:=trenutniEl^.kaj^.str+' : ';
      resitve:=prevedi (trenutniEl^.kaj, nil, 0);
      zapisi (resitve, '', 0);
      if vrsta [length (vrsta)-1]<>':' then vrsta:=copy (vrsta, 1, length (vrsta)-2);
      writeln (dat, vrsta);
      prazniDrevo (resitve);
    end;
    trenutniEl:=trenutniEl^.naslednji;
  until trenutniEl=nil;
  cas2:=time;
  lblStanje.caption:='Koncano v '+floatToStr ((cas2-cas1)*24*60*60)+' s.';
  closeFile (dat);
end;

end.
