unit podpora;

interface

type
  kVozlisce=^vozlisce;
  vozlisce=record
    str: string;
    nasNiz, nasPrevod: kVozlisce;
    d: integer;
  end;
  kElement=^element;
  element=record
    kaj, vKaj: kVozlisce;
    naslednji: kElement;
  end;

procedure narediEl (var el: kElement);
procedure dodajEl (var seznam, novi: kElement);
procedure prazniSeznam (seznam: kElement);
procedure narediVoz (var voz: kVozlisce);
procedure dodajPrevod (var drevo, novo: kVozlisce);
procedure dodajNiz (var drevo, novo: kVozlisce);
procedure prazniDrevo (drevo: kVozlisce);
function vsotaDNiz (drevo: kVozlisce): integer;

implementation

procedure narediEl (var el: kElement);
begin
  new (el);
  el^.kaj:=nil;
  el^.vkaj:=nil;
  el^.naslednji:=nil;
end;

procedure dodajEl (var seznam, novi: kElement);
  var zac: kElement;
begin
  if seznam=nil then seznam:=novi else begin
    zac:=seznam;
    while zac^.naslednji<>nil do zac:=zac^.naslednji;
    zac^.naslednji:=novi;
  end;
end;

procedure prazniSeznam (seznam: kElement);
  var zac: kElement;
begin
  while seznam<>nil do begin
    zac:=seznam;
    seznam:=seznam^.naslednji;
    prazniDrevo (zac^.kaj);
    prazniDrevo (zac^.vKaj);
    dispose (zac);
  end;
end;

procedure narediVoz (var voz: kVozlisce);
begin
  new (voz);
  voz^.nasPrevod:=nil;
  voz^.nasNiz:=nil;
  voz^.d:=0;
end;

procedure dodajPrevod (var drevo, novo: kVozlisce);
  var zac: kVozlisce;
begin
  if drevo=nil then drevo:=novo else begin
    zac:=drevo;
    while zac^.nasPrevod<>nil do zac:=zac^.nasPrevod;
    zac^.nasPrevod:=novo;
  end;
end;

procedure dodajNiz (var drevo, novo: kVozlisce);
  var zac: kVozlisce;
begin
  if drevo=nil then drevo:=novo else begin
    zac:=drevo;
    while zac^.nasNiz<>nil do zac:=zac^.nasNiz;
    zac^.nasNiz:=novo;
  end;
end;

function vsotaDNiz (drevo: kVozlisce): integer;
  var vs: integer;
begin
  vs:=0;
  while drevo<>nil do begin
    vs:=vs+drevo^.d;
    drevo:=drevo^.nasNiz;
  end;
  vsotaDNiz:=vs;
end;

procedure prazniDrevo (drevo: kVozlisce);
begin
  if drevo<>nil then begin
    prazniDrevo (drevo^.nasNiz);
    prazniDrevo (drevo^.nasPrevod);
    dispose (drevo);
  end;
end;

end.
